<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSEntryDoorPermissionBlock ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSEntryDoorPermissionBlock extends AbstractStructArrayBase
{
    /**
     * The WSEntryDoorPermissionBlock
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSEntryDoorPermissionBlock[]
     */
    public $WSEntryDoorPermissionBlock;
    /**
     * Constructor method for ArrayOfWSEntryDoorPermissionBlock
     * @uses ArrayOfWSEntryDoorPermissionBlock::setWSEntryDoorPermissionBlock()
     * @param \StructType\WSEntryDoorPermissionBlock[] $wSEntryDoorPermissionBlock
     */
    public function __construct(array $wSEntryDoorPermissionBlock = array())
    {
        $this
            ->setWSEntryDoorPermissionBlock($wSEntryDoorPermissionBlock);
    }
    /**
     * Get WSEntryDoorPermissionBlock value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSEntryDoorPermissionBlock[]|null
     */
    public function getWSEntryDoorPermissionBlock()
    {
        return isset($this->WSEntryDoorPermissionBlock) ? $this->WSEntryDoorPermissionBlock : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSEntryDoorPermissionBlock method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSEntryDoorPermissionBlock method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSEntryDoorPermissionBlockForArrayConstraintsFromSetWSEntryDoorPermissionBlock(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSEntryDoorPermissionBlockWSEntryDoorPermissionBlockItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSEntryDoorPermissionBlockWSEntryDoorPermissionBlockItem instanceof \StructType\WSEntryDoorPermissionBlock) {
                $invalidValues[] = is_object($arrayOfWSEntryDoorPermissionBlockWSEntryDoorPermissionBlockItem) ? get_class($arrayOfWSEntryDoorPermissionBlockWSEntryDoorPermissionBlockItem) : sprintf('%s(%s)', gettype($arrayOfWSEntryDoorPermissionBlockWSEntryDoorPermissionBlockItem), var_export($arrayOfWSEntryDoorPermissionBlockWSEntryDoorPermissionBlockItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSEntryDoorPermissionBlock property can only contain items of type \StructType\WSEntryDoorPermissionBlock, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSEntryDoorPermissionBlock value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSEntryDoorPermissionBlock[] $wSEntryDoorPermissionBlock
     * @return \ArrayType\ArrayOfWSEntryDoorPermissionBlock
     */
    public function setWSEntryDoorPermissionBlock(array $wSEntryDoorPermissionBlock = array())
    {
        // validation for constraint: array
        if ('' !== ($wSEntryDoorPermissionBlockArrayErrorMessage = self::validateWSEntryDoorPermissionBlockForArrayConstraintsFromSetWSEntryDoorPermissionBlock($wSEntryDoorPermissionBlock))) {
            throw new \InvalidArgumentException($wSEntryDoorPermissionBlockArrayErrorMessage, __LINE__);
        }
        if (is_null($wSEntryDoorPermissionBlock) || (is_array($wSEntryDoorPermissionBlock) && empty($wSEntryDoorPermissionBlock))) {
            unset($this->WSEntryDoorPermissionBlock);
        } else {
            $this->WSEntryDoorPermissionBlock = $wSEntryDoorPermissionBlock;
        }
        return $this;
    }
    /**
     * Add item to WSEntryDoorPermissionBlock value
     * @throws \InvalidArgumentException
     * @param \StructType\WSEntryDoorPermissionBlock $item
     * @return \ArrayType\ArrayOfWSEntryDoorPermissionBlock
     */
    public function addToWSEntryDoorPermissionBlock(\StructType\WSEntryDoorPermissionBlock $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSEntryDoorPermissionBlock) {
            throw new \InvalidArgumentException(sprintf('The WSEntryDoorPermissionBlock property can only contain items of type \StructType\WSEntryDoorPermissionBlock, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSEntryDoorPermissionBlock[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSEntryDoorPermissionBlock|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSEntryDoorPermissionBlock|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSEntryDoorPermissionBlock|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSEntryDoorPermissionBlock|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSEntryDoorPermissionBlock|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSEntryDoorPermissionBlock
     */
    public function getAttributeName()
    {
        return 'WSEntryDoorPermissionBlock';
    }
}
