<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Set ServiceType
 * @subpackage Services
 */
class Set extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named setAbsenceBlocksByPersonID
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SetAbsenceBlocksByPersonID $parameters
     * @return \StructType\SetAbsenceBlocksByPersonIDResponse|bool
     */
    public function setAbsenceBlocksByPersonID(\StructType\SetAbsenceBlocksByPersonID $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->setAbsenceBlocksByPersonID($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * setAccountDailyCorrectionByPersonDBID
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SetAccountDailyCorrectionByPersonDBID $parameters
     * @return \StructType\SetAccountDailyCorrectionByPersonDBIDResponse|bool
     */
    public function setAccountDailyCorrectionByPersonDBID(\StructType\SetAccountDailyCorrectionByPersonDBID $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->setAccountDailyCorrectionByPersonDBID($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * setAccountDailyCorrectionByPersonID
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SetAccountDailyCorrectionByPersonID $parameters
     * @return \StructType\SetAccountDailyCorrectionByPersonIDResponse|bool
     */
    public function setAccountDailyCorrectionByPersonID(\StructType\SetAccountDailyCorrectionByPersonID $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->setAccountDailyCorrectionByPersonID($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named setSessionOption
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SetSessionOption $parameters
     * @return \StructType\SetSessionOptionResponse|bool
     */
    public function setSessionOption(\StructType\SetSessionOption $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->setSessionOption($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named setAbsenceBlocksByPersonDBID
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SetAbsenceBlocksByPersonDBID $parameters
     * @return \StructType\SetAbsenceBlocksByPersonDBIDResponse|bool
     */
    public function setAbsenceBlocksByPersonDBID(\StructType\SetAbsenceBlocksByPersonDBID $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->setAbsenceBlocksByPersonDBID($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * setAccountMonthlyCorrectionByPersonDBID
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SetAccountMonthlyCorrectionByPersonDBID $parameters
     * @return \StructType\SetAccountMonthlyCorrectionByPersonDBIDResponse|bool
     */
    public function setAccountMonthlyCorrectionByPersonDBID(\StructType\SetAccountMonthlyCorrectionByPersonDBID $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->setAccountMonthlyCorrectionByPersonDBID($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * setAccountMonthlyCorrectionByPersonID
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SetAccountMonthlyCorrectionByPersonID $parameters
     * @return \StructType\SetAccountMonthlyCorrectionByPersonIDResponse|bool
     */
    public function setAccountMonthlyCorrectionByPersonID(\StructType\SetAccountMonthlyCorrectionByPersonID $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->setAccountMonthlyCorrectionByPersonID($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\SetAbsenceBlocksByPersonDBIDResponse|\StructType\SetAbsenceBlocksByPersonIDResponse|\StructType\SetAccountDailyCorrectionByPersonDBIDResponse|\StructType\SetAccountDailyCorrectionByPersonIDResponse|\StructType\SetAccountMonthlyCorrectionByPersonDBIDResponse|\StructType\SetAccountMonthlyCorrectionByPersonIDResponse|\StructType\SetSessionOptionResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
